package org.jabricks.lesson;

import java.util.List;
import java.awt.Color;
import java.awt.Font;
import java.util.ArrayList;

import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PiePlot;
import org.jfree.data.general.PieDataset;
import org.jfree.ui.HorizontalAlignment;
import org.jfree.data.category.CategoryDataset;
import org.jabricks.jfreechart.ChartDescBar;
import org.jabricks.jfreechart.JFreeChartImpl;
import org.jabricks.jfreechart.ChartDescPie;
import org.jabricks.jfreechart.CategoryDataItem;
import org.jabricks.jfreechart.PieDataItem;

public class ModuleDAO
{
	private final String[][] INCOME = {
                      {"52733", "Янв", "Доходы 2018"},
                      {"51345", "Фев", "Доходы 2018"},
                      {"52600", "Мар", "Доходы 2018"},
                      {"53300", "Апр", "Доходы 2018"},
                      {"53245", "Май", "Доходы 2018"},
                      {"53000", "Июн", "Доходы 2018"},
                      {"52100", "Июл", "Доходы 2018"},
                      {"52800", "Авг", "Доходы 2018"},
                      {"53800", "Сен", "Доходы 2018"},
                      {"54400", "Окт", "Доходы 2018"},
                      {"54500", "Ноя", "Доходы 2018"},
                      {"56600", "Дек", "Доходы 2018"},
                      {"54633", "Янв", "Доходы 2019"},
                      {"53800", "Фев", "Доходы 2019"},
                      {"53200", "Мар", "Доходы 2019"},
                      {"54500", "Апр", "Доходы 2019"},
                      {"52445", "Май", "Доходы 2019"},
                      {"55100", "Июн", "Доходы 2019"},
                      {"53300", "Июл", "Доходы 2019"},
                      {"54600", "Авг", "Доходы 2019"},
                      {"54400", "Сен", "Доходы 2019"},
                      {"52300", "Окт", "Доходы 2019"},
                      {"51400", "Ноя", "Доходы 2019"},
                      {"57800", "Дек", "Доходы 2019"}};
	private final String[][] OUTCOME = {
                      {"50733", "Янв", "Расходы 2018"},
                      {"49345", "Фев", "Расходы 2018"},
                      {"50600", "Мар", "Расходы 2018"},
                      {"51300", "Апр", "Расходы 2018"},
                      {"55245", "Май", "Расходы 2018"},
                      {"51000", "Июн", "Расходы 2018"},
                      {"50100", "Июл", "Расходы 2018"},
                      {"50800", "Авг", "Расходы 2018"},
                      {"58800", "Сен", "Расходы 2018"},
                      {"52400", "Окт", "Расходы 2018"},
                      {"52500", "Ноя", "Расходы 2018"},
                      {"54600", "Дек", "Расходы 2018"},
                      {"52633", "Янв", "Расходы 2019"},
                      {"51800", "Фев", "Расходы 2019"},
                      {"51200", "Мар", "Расходы 2019"},
                      {"59500", "Апр", "Расходы 2019"},
                      {"50445", "Май", "Расходы 2019"},
                      {"50100", "Июн", "Расходы 2019"},
                      {"51300", "Июл", "Расходы 2019"},
                      {"62600", "Авг", "Расходы 2019"},
                      {"52400", "Сен", "Расходы 2019"},
                      {"50300", "Окт", "Расходы 2019"},
                      {"58400", "Ноя", "Расходы 2019"},
                      {"55800", "Дек", "Расходы 2019"}};
	
	private final String[][] SECTIONS = {
			          {"99535" , "Квартира"           },
			          {"520000", "Питание"            },
			          {"48000" , "Бассейн, фитнес"    }, 
			          {"235450", "Развлечения, отпуск"},
			          {"58600" , "Автомобиль"         },
			          {"15000" , "Дача"              }};
	//-----------------------------------------------------
	public ModuleDAO(){}
	//-----------------------------------------------------
	private CategoryDataset createIncomeDataset()
	{
		return createDataset(INCOME);
	}
	//-----------------------------------------------------
	private CategoryDataset createOutcomeDataset()
	{
		return createDataset(OUTCOME);
	}
	//-----------------------------------------------------
	private CategoryDataset createDataset(String[][] data)
	{
		List<CategoryDataItem> list;
		list = new ArrayList<CategoryDataItem>();
		for (int i = 0; i < INCOME.length; i++) {
			CategoryDataItem rc = new CategoryDataItem();
			rc.setValue    (Double.valueOf(INCOME[i][0]));
			rc.setColumnKey(INCOME[i][1]);
			rc.setRowKey   (INCOME[i][2]);
			list.add(rc);
		}
		JFreeChartImpl fci = new JFreeChartImpl();
		return fci.createCategoryDataset(list);
	}
	//-----------------------------------------------------
	private PieDataset createPieDataset()
	{
		List<PieDataItem> data_pie;
		data_pie = new ArrayList<PieDataItem>();
		for (int i = 0; i < SECTIONS.length; i++) {
			PieDataItem rp;
			double value = Double.valueOf(SECTIONS[i][0])
					             .doubleValue();
			rp = new PieDataItem(SECTIONS[i][1], value);
			data_pie.add(rp);
		}
		JFreeChartImpl fci = new JFreeChartImpl();
		return fci.createPieDataset(data_pie);
	}
	//-----------------------------------------------------
	public ChartPanel createBarChart(final String title,
			                         final String y_axis,
			                         CategoryDataset dataset)
	{
    	ChartDescBar cdb;
    	cdb = new ChartDescBar(title, null, y_axis, dataset); 
    	cdb.setSubtitle("за 2018-2019 гг");
   		return createBarChart(cdb);
	}
	//-----------------------------------------------------
	public ChartPanel createBarChartIncome()
	{
    	CategoryDataset dataset = createIncomeDataset();
//    	
//    	ChartDescBar cdb;
    	String title  = "Диаграмма о доходах";
    	String y_axis = "Доход";
//    	cdb = new ChartDescBar(title, null, y_axis, dataset); 
//    	cdb.setSubtitle("за 2018-2019 гг");
//   	return createChartPanel(cdb);
   		
   		return createBarChart(title, y_axis, dataset);
	}
	//-----------------------------------------------------
	public ChartPanel createBarChartOutcome()
	{
    	CategoryDataset dataset = createOutcomeDataset();
    	
//    	ChartDescBar cdb;
    	String title  = "Диаграмма о расходах";
    	String y_axis = "Расходы";
//    	cdb = new ChartDescBar(title, null, y_axis, dataset);
//    	cdb.setSubtitle("за 2018-2019 гг");
// 		return createChartPanel(cdb);
   		return createBarChart(title, y_axis, dataset);
	}
	//-----------------------------------------------------
	public ChartPanel createPieChartOutcome()
	{
		PieDataset dataset = createPieDataset();
    	
		ChartDescPie cdp = new ChartDescPie();
		cdp.setTitle   ("Диаграмма расходов");
		cdp.setSubtitle("2018 год");
		cdp.setDataset (dataset);
		cdp.setLegend  (false);
		cdp.setTooltips(true);

		cdp.setTextTitleAlignment(HorizontalAlignment.LEFT);
		
		Font font = new Font("Courier New", 
				             Font.PLAIN | Font.ITALIC, 11);
		cdp.setSubtextTitleFont(font);
//		cdp.setSubtextTitlePosition(RectangleEdge.BOTTOM);
//		cdp.setSubtextTitleAlignment(HorizontalAlignment.RIGHT);
		return createPieChart(cdp);
	}
	//-----------------------------------------------------
	private ChartPanel createBarChart(ChartDescBar cdb)
	{
	    // Утилита создания диаграммы
    	JFreeChartImpl fci = new JFreeChartImpl();
        // Создание диаграммы
    	JFreeChart chart = fci.createBarChart(cdb);
        // Скрытие шкал
    	fci.hideAxisLineX (chart.getCategoryPlot());
    	fci.hideAxisLineY (chart.getCategoryPlot());

    	return new ChartPanel(chart); 
	}
	//-----------------------------------------------------
	private ChartPanel createPieChart(ChartDescPie cdp)
	{
    	JFreeChartImpl fci = new JFreeChartImpl();
    	JFreeChart chart = fci.createPieChart(cdp);
    	
    	PiePlot plot = (PiePlot) chart.getPlot();
    	 // Настройка меток названий секций
    	Font font = new Font("Arial", Font.BOLD, 11);
        fci.setPiePlotLabels(plot, font, Color.DARK_GRAY, 
        		                         Color.DARK_GRAY);
   		return new ChartPanel(chart); 
	}
	//-----------------------------------------------------
}
